#Использовать asserts
#Использовать ".."
#Использовать "."

&ТестовыйНабор
Процедура ПриСозданииОбъекта() Экспорт
КонецПроцедуры

&Тест
Процедура ТестПростогоМассиваFlowStyle() Экспорт
    // Дано
    СтрокаYAML = "simple_array: [1, 2, 3]";
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СтрокаYAML);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    МассивЗначений = Результат.Получить("simple_array");
    Ожидаем.Что(МассивЗначений).Не_().ЭтоНеопределено();
    Ожидаем.Что(ТипЗнч(МассивЗначений)).Равно(Тип("Массив"));
    Ожидаем.Что(МассивЗначений.Количество()).Равно(3);
    Ожидаем.Что(МассивЗначений[0]).Равно(1);
    Ожидаем.Что(МассивЗначений[1]).Равно(2);
    Ожидаем.Что(МассивЗначений[2]).Равно(3);
КонецПроцедуры

&Тест
Процедура ТестСтроковогоМассиваFlowStyle() Экспорт
    // Дано
    СтрокаYAML = "string_array: [""apple"", ""banana"", ""cherry""]";
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СтрокаYAML);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    МассивЗначений = Результат.Получить("string_array");
    Ожидаем.Что(МассивЗначений).Не_().ЭтоНеопределено();
    Ожидаем.Что(ТипЗнч(МассивЗначений)).Равно(Тип("Массив"));
    Ожидаем.Что(МассивЗначений.Количество()).Равно(3);
    Ожидаем.Что(МассивЗначений[0]).Равно("apple");
    Ожидаем.Что(МассивЗначений[1]).Равно("banana");
    Ожидаем.Что(МассивЗначений[2]).Равно("cherry");
КонецПроцедуры

&Тест
Процедура ТестПустогоМассиваFlowStyle() Экспорт
    // Дано
    СтрокаYAML = "empty_array: []";
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СтрокаYAML);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    МассивЗначений = Результат.Получить("empty_array");
    Ожидаем.Что(МассивЗначений).Не_().ЭтоНеопределено();
    Ожидаем.Что(ТипЗнч(МассивЗначений)).Равно(Тип("Массив"));
    Ожидаем.Что(МассивЗначений.Количество()).Равно(0);
КонецПроцедуры

&Тест
Процедура ТестСмешанногоМассиваFlowStyle() Экспорт
    // Дано
    СтрокаYAML = "mixed_array: [1, ""hello"", true, null]";
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СтрокаYAML);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    МассивЗначений = Результат.Получить("mixed_array");
    Ожидаем.Что(МассивЗначений).Не_().ЭтоНеопределено();
    Ожидаем.Что(ТипЗнч(МассивЗначений)).Равно(Тип("Массив"));
    Ожидаем.Что(МассивЗначений.Количество()).Равно(4);
    Ожидаем.Что(МассивЗначений[0]).Равно(1);
    Ожидаем.Что(МассивЗначений[1]).Равно("hello");
    Ожидаем.Что(МассивЗначений[2]).Равно(Истина);
    // Проверка на null/Неопределено
    Ожидаем.Что(МассивЗначений[3]).ЭтоНеопределено();
КонецПроцедуры

&Тест
Процедура ТестПростогоОбъектаFlowStyle() Экспорт
    // Дано
    СтрокаYAML = "simple_object: {name: ""John"", age: 30}";
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СтрокаYAML);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    ОбъектЗначений = Результат.Получить("simple_object");
    Ожидаем.Что(ОбъектЗначений).Не_().ЭтоНеопределено();
    Ожидаем.Что(ТипЗнч(ОбъектЗначений)).Равно(Тип("Соответствие"));
    Ожидаем.Что(ОбъектЗначений.Получить("name")).Равно("John");
    Ожидаем.Что(ОбъектЗначений.Получить("age")).Равно(30);
КонецПроцедуры

&Тест
Процедура ТестПустогоОбъектаFlowStyle() Экспорт
    // Дано
    СтрокаYAML = "empty_object: {}";
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СтрокаYAML);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    ОбъектЗначений = Результат.Получить("empty_object");
    Ожидаем.Что(ОбъектЗначений).Не_().ЭтоНеопределено();
    Ожидаем.Что(ТипЗнч(ОбъектЗначений)).Равно(Тип("Соответствие"));
    Ожидаем.Что(ОбъектЗначений.Количество()).Равно(0);
КонецПроцедуры

&Тест
Процедура ТестВложенногоМассиваFlowStyle() Экспорт
    // Дано
    СтрокаYAML = "nested_array: [1, [2, 3], 4]";
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СтрокаYAML);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    МассивЗначений = Результат.Получить("nested_array");
    Ожидаем.Что(МассивЗначений).Не_().ЭтоНеопределено();
    Ожидаем.Что(ТипЗнч(МассивЗначений)).Равно(Тип("Массив"));
    Ожидаем.Что(МассивЗначений.Количество()).Равно(3);
    Ожидаем.Что(МассивЗначений[0]).Равно(1);
    
    ВложенныйМассив = МассивЗначений[1];
    Ожидаем.Что(ТипЗнч(ВложенныйМассив)).Равно(Тип("Массив"));
    Ожидаем.Что(ВложенныйМассив.Количество()).Равно(2);
    Ожидаем.Что(ВложенныйМассив[0]).Равно(2);
    Ожидаем.Что(ВложенныйМассив[1]).Равно(3);
    
    Ожидаем.Что(МассивЗначений[2]).Равно(4);
КонецПроцедуры

&Тест
Процедура ТестВложенногоОбъектаFlowStyle() Экспорт
    // Дано
    СтрокаYAML = "nested_object: {user: {name: ""John"", age: 30}, metadata: {created: ""2023-01-01""}}";
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СтрокаYAML);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    ОбъектЗначений = Результат.Получить("nested_object");
    Ожидаем.Что(ОбъектЗначений).Не_().ЭтоНеопределено();
    Ожидаем.Что(ТипЗнч(ОбъектЗначений)).Равно(Тип("Соответствие"));
    
    ПользовательОбъект = ОбъектЗначений.Получить("user");
    Ожидаем.Что(ТипЗнч(ПользовательОбъект)).Равно(Тип("Соответствие"));
    Ожидаем.Что(ПользовательОбъект.Получить("name")).Равно("John");
    Ожидаем.Что(ПользовательОбъект.Получить("age")).Равно(30);
    
    МетаданныеОбъект = ОбъектЗначений.Получить("metadata");
    Ожидаем.Что(ТипЗнч(МетаданныеОбъект)).Равно(Тип("Соответствие"));
    Ожидаем.Что(МетаданныеОбъект.Получить("created")).Равно("2023-01-01");
КонецПроцедуры

&Тест
Процедура ТестСмешанногоFlowИBlockStyle() Экспорт
    // Дано
    СтрокаYAML = 
    "mixed_array:
    |  - {name: ""John"", age: 30}
    |  - {name: ""Jane"", age: 25}";
    СтрокаYAML = СтрЗаменить(СтрокаYAML, "|", "");
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СтрокаYAML);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    МассивЗначений = Результат.Получить("mixed_array");
    Ожидаем.Что(МассивЗначений).Не_().ЭтоНеопределено();
    Ожидаем.Что(ТипЗнч(МассивЗначений)).Равно(Тип("Массив"));
    Ожидаем.Что(МассивЗначений.Количество()).Равно(2);
    
    ПервыйЭлемент = МассивЗначений[0];
    Ожидаем.Что(ТипЗнч(ПервыйЭлемент)).Равно(Тип("Соответствие"));
    Ожидаем.Что(ПервыйЭлемент.Получить("name")).Равно("John");
    Ожидаем.Что(ПервыйЭлемент.Получить("age")).Равно(30);
    
    ВторойЭлемент = МассивЗначений[1];
    Ожидаем.Что(ТипЗнч(ВторойЭлемент)).Равно(Тип("Соответствие"));
    Ожидаем.Что(ВторойЭлемент.Получить("name")).Равно("Jane");
    Ожидаем.Что(ВторойЭлемент.Получить("age")).Равно(25);
КонецПроцедуры

&Тест
Процедура ТестПолногоФайлаFlowStyle() Экспорт
    // Дано
    СодержимоеФайла = ТестовыеУтилиты.ПрочитатьТекстФайла(ТестовыеУтилиты.ПолучитьПутьКТестовымДанным("flow_style.yaml"));
    // Для теста используем только первые 12 строк файла
    СтрокиФайла = СтрРазделить(СодержимоеФайла, Символы.ПС);
    ЧистоеСодержимое = "";
    Для Индекс = 0 По Мин(12, СтрокиФайла.ВГраница()) Цикл
        ЧистоеСодержимое = ЧистоеСодержимое + СтрокиФайла[Индекс] + Символы.ПС;
    КонецЦикла;
    
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(ЧистоеСодержимое);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    
    // Проверяем простые массивы
    ПростойМассив = Результат.Получить("simple_array");
    Ожидаем.Что(ТипЗнч(ПростойМассив)).Равно(Тип("Массив"));
    Ожидаем.Что(ПростойМассив.Количество()).Равно(3);
    
    // Проверяем простые объекты
    ПростойОбъект = Результат.Получить("simple_object");
    Ожидаем.Что(ТипЗнч(ПростойОбъект)).Равно(Тип("Соответствие"));
    Ожидаем.Что(ПростойОбъект.Получить("name")).Равно("John");
    Ожидаем.Что(ПростойОбъект.Получить("age")).Равно(30);
    
    // Проверяем пустые коллекции
    ПустойМассив = Результат.Получить("empty_array");
    Ожидаем.Что(ТипЗнч(ПустойМассив)).Равно(Тип("Массив"));
    Ожидаем.Что(ПустойМассив.Количество()).Равно(0);
    
    ПустойОбъект = Результат.Получить("empty_object");
    Ожидаем.Что(ТипЗнч(ПустойОбъект)).Равно(Тип("Соответствие"));
    Ожидаем.Что(ПустойОбъект.Количество()).Равно(0);
КонецПроцедуры

&Тест
Процедура ТестОшибкиFlowStyleНеПарныеСкобки() Экспорт
    // Дано
    СтрокаYAML = "broken_array: [1, 2, 3"; // Отсутствует закрывающая скобка
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда/Тогда
    Попытка
        ЧтениеYaml.ПрочитатьYaml(СтрокаYAML);
        ВызватьИсключение("Должно было быть выброшено исключение");
    Исключение
        // Ожидаем исключение при некорректном синтаксисе
        ТекстОшибки = ОписаниеОшибки();
        Ожидаем.Что(ТекстОшибки).Содержит("незакрытая скобка");
    КонецПопытки;
КонецПроцедуры

&Тест
Процедура ТестМногострочногоFlowStyleМассива() Экспорт
    // Дано
    СтрокаYAML = 
    "multiline_array: [
    |  1,
    |  2,
    |  3
    |]";
    СтрокаYAML = СтрЗаменить(СтрокаYAML, "|", "");
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СтрокаYAML);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    МассивЗначений = Результат.Получить("multiline_array");
    Ожидаем.Что(МассивЗначений).Не_().ЭтоНеопределено();
    Ожидаем.Что(ТипЗнч(МассивЗначений)).Равно(Тип("Массив"));
    Ожидаем.Что(МассивЗначений.Количество()).Равно(3);
    Ожидаем.Что(МассивЗначений[0]).Равно(1);
    Ожидаем.Что(МассивЗначений[1]).Равно(2);
    Ожидаем.Что(МассивЗначений[2]).Равно(3);
КонецПроцедуры

&Тест
Процедура ТестМногострочногоFlowStyleОбъекта() Экспорт
    // Дано
    СтрокаYAML = 
    "multiline_object: {
    |  name: ""John"",
    |  age: 30,
    |  city: ""NYC""
    |}";
    СтрокаYAML = СтрЗаменить(СтрокаYAML, "|", "");
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СтрокаYAML);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    ОбъектЗначений = Результат.Получить("multiline_object");
    Ожидаем.Что(ОбъектЗначений).Не_().ЭтоНеопределено();
    Ожидаем.Что(ТипЗнч(ОбъектЗначений)).Равно(Тип("Соответствие"));
    Ожидаем.Что(ОбъектЗначений.Получить("name")).Равно("John");
    Ожидаем.Что(ОбъектЗначений.Получить("age")).Равно(30);
    Ожидаем.Что(ОбъектЗначений.Получить("city")).Равно("NYC");
КонецПроцедуры

&Тест
Процедура ТестСложногоМногострочногоFlowStyle() Экспорт
    // Дано
    СтрокаYAML = 
    "complex_multiline: {
    |  users: [
    |    {name: ""John"", age: 30},
    |    {name: ""Jane"", age: 25}
    |  ],
    |  metadata: {
    |    version: 1.0,
    |    tags: [""prod"", ""api""]
    |  }
    |}";
    СтрокаYAML = СтрЗаменить(СтрокаYAML, "|", "");
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СтрокаYAML);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    КомплексныйОбъект = Результат.Получить("complex_multiline");
    Ожидаем.Что(КомплексныйОбъект).Не_().ЭтоНеопределено();
    Ожидаем.Что(ТипЗнч(КомплексныйОбъект)).Равно(Тип("Соответствие"));
    
    // Проверяем пользователей
    Пользователи = КомплексныйОбъект.Получить("users");
    Ожидаем.Что(ТипЗнч(Пользователи)).Равно(Тип("Массив"));
    Ожидаем.Что(Пользователи.Количество()).Равно(2);
    
    ПервыйПользователь = Пользователи[0];
    Ожидаем.Что(ТипЗнч(ПервыйПользователь)).Равно(Тип("Соответствие"));
    Ожидаем.Что(ПервыйПользователь.Получить("name")).Равно("John");
    Ожидаем.Что(ПервыйПользователь.Получить("age")).Равно(30);
    
    // Проверяем метаданные
    Метаданные = КомплексныйОбъект.Получить("metadata");
    Ожидаем.Что(ТипЗнч(Метаданные)).Равно(Тип("Соответствие"));
    Ожидаем.Что(Метаданные.Получить("version")).Равно(1.0);
    
    Теги = Метаданные.Получить("tags");
    Ожидаем.Что(ТипЗнч(Теги)).Равно(Тип("Массив"));
    Ожидаем.Что(Теги.Количество()).Равно(2);
    Ожидаем.Что(Теги[0]).Равно("prod");
    Ожидаем.Что(Теги[1]).Равно("api");
КонецПроцедуры
