#Использовать asserts
#Использовать ".."
#Использовать "."

&ТестовыйНабор
Процедура ПриСозданииОбъекта() Экспорт
КонецПроцедуры

&Тест
Процедура ТестПарсингаВложенногоYAML() Экспорт
    // Дано
    СодержимоеФайла = ТестовыеУтилиты.ПрочитатьТекстФайла(ТестовыеУтилиты.ПолучитьПутьКТестовымДанным("nested.yaml"));
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СодержимоеФайла);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    
    Персона = Результат.Получить("person");
    Ожидаем.Что(Персона).Не_().ЭтоНеопределено();
    Ожидаем.Что(Персона.Получить("name")).Равно("Jane Smith");
    Ожидаем.Что(Персона.Получить("age")).Равно(25);
    
    Адрес = Персона.Получить("address");
    Ожидаем.Что(Адрес).Не_().ЭтоНеопределено();
    Ожидаем.Что(Адрес.Получить("street")).Равно("123 Main St");
    Ожидаем.Что(Адрес.Получить("city")).Равно("New York");
КонецПроцедуры

&Тест
Процедура ТестПарсингаСмешанныхТипов() Экспорт
    // Дано
    СодержимоеФайла = ТестовыеУтилиты.ПрочитатьТекстФайла(ТестовыеУтилиты.ПолучитьПутьКТестовымДанным("mixed.yaml"));
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СодержимоеФайла);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    
    Смешанное = Результат.Получить("mixed");
    Ожидаем.Что(Смешанное).Не_().ЭтоНеопределено();
    
    // Проверяем строку
    Ожидаем.Что(Смешанное.Получить("string_value")).Равно("Hello World");
    
    // Проверяем число
    Ожидаем.Что(Смешанное.Получить("number_value")).Равно(42);
    
    // Проверяем булево значение
    Ожидаем.Что(Смешанное.Получить("boolean_value")).Равно(Истина);
    
    // Проверяем null
    Ожидаем.Что(Смешанное.Получить("null_value")).ЭтоНеопределено();
    
    // Проверяем массив
    Массив = Смешанное.Получить("array");
    Ожидаем.Что(Массив).Не_().ЭтоНеопределено();
    Ожидаем.Что(Массив.Количество()).Равно(3);
    Ожидаем.Что(Массив[0]).Равно("item1");
    Ожидаем.Что(Массив[1]).Равно(123);
    Ожидаем.Что(Массив[2]).Равно(Ложь);
КонецПроцедуры
