#Использовать asserts
#Использовать ".."
#Использовать "."

&ТестовыйНабор
Процедура ПриСозданииОбъекта() Экспорт
КонецПроцедуры

&Тест
Процедура ТестПарсингаПростыхМассивов() Экспорт
    // Дано
    СодержимоеФайла = ТестовыеУтилиты.ПрочитатьТекстФайла(ТестовыеУтилиты.ПолучитьПутьКТестовымДанным("array.yaml"));
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СодержимоеФайла);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    
    Фрукты = Результат.Получить("fruits");
    Ожидаем.Что(Фрукты).Не_().ЭтоНеопределено();
    Ожидаем.Что(Фрукты.Количество()).Равно(3);
    Ожидаем.Что(Фрукты[0]).Равно("apple");
    Ожидаем.Что(Фрукты[1]).Равно("banana");
    Ожидаем.Что(Фрукты[2]).Равно("orange");
    
    Числа = Результат.Получить("numbers");
    Ожидаем.Что(Числа).Не_().ЭтоНеопределено();
    Ожидаем.Что(Числа.Количество()).Равно(3);
    Ожидаем.Что(Числа[0]).Равно(1);
    Ожидаем.Что(Числа[1]).Равно(2);
    Ожидаем.Что(Числа[2]).Равно(3);
КонецПроцедуры

&Тест
Процедура ТестПростогоМассиваОбъектов() Экспорт
    // Дано
    СодержимоеФайла = ТестовыеУтилиты.ПрочитатьТекстФайла(ТестовыеУтилиты.ПолучитьПутьКТестовымДанным("simple_array_objects.yaml"));
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СодержимоеФайла);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    
    Элементы = Результат.Получить("items");
    Ожидаем.Что(Элементы).Не_().ЭтоНеопределено();
    Ожидаем.Что(Элементы.Количество()).Равно(2);
    
    // Первый объект
    Объект1 = Элементы[0];
    Ожидаем.Что(ТипЗнч(Объект1)).Равно(Тип("Соответствие"));
    Ожидаем.Что(Объект1.Получить("name")).Равно("first");
    
    // Второй объект
    Объект2 = Элементы[1];
    Ожидаем.Что(ТипЗнч(Объект2)).Равно(Тип("Соответствие"));
    Ожидаем.Что(Объект2.Получить("name")).Равно("second");
КонецПроцедуры
