#Использовать asserts
#Использовать ".."
#Использовать "."

&ТестовыйНабор
Процедура ПриСозданииОбъекта() Экспорт
КонецПроцедуры

&Тест
Процедура ТестПарсингаОбщихОбластей() Экспорт
    // Дано
    СодержимоеФайла = ТестовыеУтилиты.ПрочитатьТекстФайла(ТестовыеУтилиты.ПолучитьПутьКТестовымДанным("anchors.yaml"));
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СодержимоеФайла);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    
    // Проверяем, что общие области были корректно обработаны и развернуты
    
    // 1. Проверяем production конфигурацию
    Production = Результат.Получить("production");
    Ожидаем.Что(Production).Не_().ЭтоНеопределено();
    
    // База данных production должна содержать настройки из db_defaults + свои
    БДProduction = Production.Получить("database");
    Ожидаем.Что(БДProduction.Получить("host")).Равно("localhost");
    Ожидаем.Что(БДProduction.Получить("port")).Равно(5432);
    Ожидаем.Что(БДProduction.Получить("timeout")).Равно(30);
    Ожидаем.Что(БДProduction.Получить("ssl")).Равно(Истина);
    Ожидаем.Что(БДProduction.Получить("name")).Равно("prod_db");
    Ожидаем.Что(БДProduction.Получить("user")).Равно("prod_user");
    
    // Приложение production должно содержать настройки из app_defaults + переопределенные
    ПриложениеProduction = Production.Получить("application");
    Ожидаем.Что(ПриложениеProduction.Получить("debug")).Равно(Ложь);
    Ожидаем.Что(ПриложениеProduction.Получить("log_level")).Равно("info");
    Ожидаем.Что(ПриложениеProduction.Получить("workers")).Равно(8); // переопределено
    
    // 2. Проверяем development конфигурацию
    Development = Результат.Получить("development");
    Ожидаем.Что(Development).Не_().ЭтоНеопределено();
    
    // База данных development
    БДDevelopment = Development.Получить("database");
    Ожидаем.Что(БДDevelopment.Получить("host")).Равно("localhost");
    Ожидаем.Что(БДDevelopment.Получить("port")).Равно(5433); // переопределено
    Ожидаем.Что(БДDevelopment.Получить("timeout")).Равно(30);
    Ожидаем.Что(БДDevelopment.Получить("ssl")).Равно(Истина);
    Ожидаем.Что(БДDevelopment.Получить("name")).Равно("dev_db");
    Ожидаем.Что(БДDevelopment.Получить("user")).Равно("dev_user");
    
    // Приложение development
    ПриложениеDevelopment = Development.Получить("application");
    Ожидаем.Что(ПриложениеDevelopment.Получить("debug")).Равно(Истина); // переопределено
    Ожидаем.Что(ПриложениеDevelopment.Получить("log_level")).Равно("debug"); // переопределено
    Ожидаем.Что(ПриложениеDevelopment.Получить("workers")).Равно(4);
    
    // 3. Проверяем массив сервисов
    Сервисы = Результат.Получить("services");
    Ожидаем.Что(Сервисы).Не_().ЭтоНеопределено();
    Ожидаем.Что(Сервисы.Количество()).Равно(2);
    
    // Первый сервис
    Сервис1 = Сервисы[0];
    Ожидаем.Что(Сервис1.Получить("name")).Равно("user-service");
    Ожидаем.Что(Сервис1.Получить("port")).Равно(8080);
    
    // Второй сервис
    Сервис2 = Сервисы[1];
    Ожидаем.Что(Сервис2.Получить("name")).Равно("user-service");
    Ожидаем.Что(Сервис2.Получить("port")).Равно(8081);
    
    // 4. Проверяем прямые ссылки на значения
    Api = Результат.Получить("api");
    Ожидаем.Что(Api).Не_().ЭтоНеопределено();
    Ожидаем.Что(Api.Получить("timeout")).Равно(30);
    Ожидаем.Что(Api.Получить("retries")).Равно(3);
    
    // 5. Убеждаемся, что определения якорей не попали в результат
    Ожидаем.Что(Результат.Получить("default_db")).ЭтоНеопределено();
    Ожидаем.Что(Результат.Получить("app_config")).ЭтоНеопределено();
    Ожидаем.Что(Результат.Получить("service_name")).ЭтоНеопределено();
    Ожидаем.Что(Результат.Получить("default_timeout")).ЭтоНеопределено();
КонецПроцедуры

&Тест
Процедура ТестПростыхСсылокНаЗначения() Экспорт
    // Дано
    ТекстYaml = "
    |shared_value: &shared 42
    |first: *shared
    |second: *shared
    |different: 100
    |";
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(ТекстYaml);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    Ожидаем.Что(Результат.Получить("first")).Равно(42);
    Ожидаем.Что(Результат.Получить("second")).Равно(42);
    Ожидаем.Что(Результат.Получить("different")).Равно(100);
    
    // Определение якоря не должно попасть в результат
    Ожидаем.Что(Результат.Получить("shared_value")).ЭтоНеопределено();
КонецПроцедуры
