#Использовать asserts
#Использовать ".."
#Использовать "."

&ТестовыйНабор
Процедура ПриСозданииОбъекта() Экспорт
КонецПроцедуры

&Тест
Процедура ТестСмешанныхОтступовСПробеламиИТабами() Экспорт
    // Дано
    СодержимоеФайла = ТестовыеУтилиты.ПрочитатьТекстФайла(ТестовыеУтилиты.ПолучитьПутьКТестовымДанным("mixed_indentation.yaml"));
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СодержимоеФайла);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    ПервыйУровень = Результат.Получить("first_level");
    Ожидаем.Что(ПервыйУровень).Не_().ЭтоНеопределено();
    Ожидаем.Что(ПервыйУровень.Получить("string_with_spaces")).Равно("value1");
    Ожидаем.Что(ПервыйУровень.Получить("string_with_tab")).Равно("value2");
    
    Вложенный = ПервыйУровень.Получить("nested");
    Ожидаем.Что(Вложенный).Не_().ЭтоНеопределено();
    Ожидаем.Что(Вложенный.Получить("mixed_indent")).Равно("value3");
    Ожидаем.Что(Вложенный.Получить("consistent_spaces")).Равно("value4");
КонецПроцедуры

&Тест
Процедура ТестНекорректногоУровняОтступа() Экспорт
    // Дано
    СодержимоеФайла = ТестовыеУтилиты.ПрочитатьТекстФайла(ТестовыеУтилиты.ПолучитьПутьКТестовымДанным("incorrect_indentation.yaml"));
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда/Тогда
    // По спецификации YAML некорректные отступы должны вызывать ошибку
    Попытка
        ЧтениеYaml.ПрочитатьYaml(СодержимоеФайла);
        // Если дошли сюда, то исключение не было выброшено
        Ожидаем.Что(Ложь).ЭтоИстина("Ожидалось исключение при некорректных отступах");
    Исключение
        // Проверяем, что исключение содержит ожидаемый текст
        Ожидаем.Что(ОписаниеОшибки()).Содержит("Ошибка парсинга YAML");
        Ожидаем.Что(ОписаниеОшибки()).Содержит("Несогласованный отступ");
    КонецПопытки;
КонецПроцедуры

&Тест
Процедура ТестКонсистентностиОтступов() Экспорт
    // Дано - в этом YAML используется смесь из 2 и 4 пробелов для отступов
    СодержимоеФайла = ТестовыеУтилиты.ПрочитатьТекстФайла(ТестовыеУтилиты.ПолучитьПутьКТестовымДанным("inconsistent_indentation.yaml"));
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СодержимоеФайла);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    
    Уровень1 = Результат.Получить("level1");
    Ожидаем.Что(Уровень1).Не_().ЭтоНеопределено();
    
    Уровень2 = Уровень1.Получить("level2_with_2_spaces");
    Ожидаем.Что(Уровень2).Не_().ЭтоНеопределено();
    
    Уровень3 = Уровень2.Получить("level3_with_4_spaces");
    Ожидаем.Что(Уровень3).Равно("value1");
    
    Уровень4 = Уровень2.Получить("level4_with_6_spaces");
    Ожидаем.Что(Уровень4).Равно("value2");
    
    Уровень1Снова = Результат.Получить("level1_again");
    Ожидаем.Что(Уровень1Снова).Не_().ЭтоНеопределено();
    
    Уровень2Снова = Уровень1Снова.Получить("level2_with_4_spaces");
    Ожидаем.Что(Уровень2Снова).Равно("value3");
    
    Уровень3Снова = Уровень1Снова.Получить("level3_with_8_spaces");
    Ожидаем.Что(Уровень3Снова).Равно("value4");
КонецПроцедуры
