#Использовать asserts
#Использовать ".."
#Использовать "."

&ТестовыйНабор
Процедура ПриСозданииОбъекта() Экспорт
КонецПроцедуры

&Тест
Процедура ТестПустогоМассиваBlockStyle() Экспорт
    // Дано
    СтрокаYAML = "empty_array:";
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СтрокаYAML);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    МассивЗначений = Результат.Получить("empty_array");
    // Пустой массив в Block Style должен быть Неопределено или пустым массивом
    Ожидаем.Что(МассивЗначений).ЭтоНеопределено();
КонецПроцедуры

&Тест
Процедура ТестПустогоОбъектаBlockStyle() Экспорт
    // Дано
    СтрокаYAML = "empty_object:";
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СтрокаYAML);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    ОбъектЗначений = Результат.Получить("empty_object");
    // Пустой объект в Block Style должен быть Неопределено или пустым соответствием
    Ожидаем.Что(ОбъектЗначений).ЭтоНеопределено();
КонецПроцедуры

&Тест
Процедура ТестПустогоМассиваFlowStyle() Экспорт
    // Дано
    СтрокаYAML = "empty_array: []";
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СтрокаYAML);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    МассивЗначений = Результат.Получить("empty_array");
    Ожидаем.Что(МассивЗначений).Не_().ЭтоНеопределено();
    Ожидаем.Что(ТипЗнч(МассивЗначений)).Равно(Тип("Массив"));
    Ожидаем.Что(МассивЗначений.Количество()).Равно(0);
КонецПроцедуры

&Тест
Процедура ТестПустогоОбъектаFlowStyle() Экспорт
    // Дано
    СтрокаYAML = "empty_object: {}";
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СтрокаYAML);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    ОбъектЗначений = Результат.Получить("empty_object");
    Ожидаем.Что(ОбъектЗначений).Не_().ЭтоНеопределено();
    Ожидаем.Что(ТипЗнч(ОбъектЗначений)).Равно(Тип("Соответствие"));
    Ожидаем.Что(ОбъектЗначений.Количество()).Равно(0);
КонецПроцедуры

&Тест
Процедура ТестПустогоМассиваЯвныйNull() Экспорт
    // Дано
    СтрокаYAML = "empty_array: null";
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СтрокаYAML);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    МассивЗначений = Результат.Получить("empty_array");
    Ожидаем.Что(МассивЗначений).ЭтоНеопределено();
КонецПроцедуры

&Тест
Процедура ТестПустогоМассиваЯвныйТильда() Экспорт
    // Дано
    СтрокаYAML = "empty_array: ~";
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СтрокаYAML);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    МассивЗначений = Результат.Получить("empty_array");
    Ожидаем.Что(МассивЗначений).ЭтоНеопределено();
КонецПроцедуры

&Тест
Процедура ТестВложенныхПустыхКоллекций() Экспорт
    // Дано
    СтрокаYAML = 
    "parent:
    |  empty_array: []
    |  empty_object: {}
    |  null_value: null
    |  empty_value:";
    СтрокаYAML = СтрЗаменить(СтрокаYAML, "|", "");
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СтрокаYAML);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    Родитель = Результат.Получить("parent");
    Ожидаем.Что(Родитель).Не_().ЭтоНеопределено();
    Ожидаем.Что(ТипЗнч(Родитель)).Равно(Тип("Соответствие"));
    
    // Проверяем пустой массив
    ПустойМассив = Родитель.Получить("empty_array");
    Ожидаем.Что(ТипЗнч(ПустойМассив)).Равно(Тип("Массив"));
    Ожидаем.Что(ПустойМассив.Количество()).Равно(0);
    
    // Проверяем пустой объект
    ПустойОбъект = Родитель.Получить("empty_object");
    Ожидаем.Что(ТипЗнч(ПустойОбъект)).Равно(Тип("Соответствие"));
    Ожидаем.Что(ПустойОбъект.Количество()).Равно(0);
    
    // Проверяем null значение
    НullЗначение = Родитель.Получить("null_value");
    Ожидаем.Что(НullЗначение).ЭтоНеопределено();
    
    // Проверяем пустое значение
    ПустоеЗначение = Родитель.Получить("empty_value");
    Ожидаем.Что(ПустоеЗначение).ЭтоНеопределено();
КонецПроцедуры

&Тест
Процедура ТестКомбинацииПустыхИНепустыхКоллекций() Экспорт
    // Дано
    СтрокаYAML = 
    "mixed:
    |  empty_list: []
    |  filled_list: [1, 2, 3]
    |  empty_dict: {}
    |  filled_dict: {key: value}
    |  null_list: null
    |  implicit_empty:";
    СтрокаYAML = СтрЗаменить(СтрокаYAML, "|", "");
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СтрокаYAML);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    Смешанное = Результат.Получить("mixed");
    Ожидаем.Что(Смешанное).Не_().ЭтоНеопределено();
    
    // Пустой список
    ПустойСписок = Смешанное.Получить("empty_list");
    Ожидаем.Что(ТипЗнч(ПустойСписок)).Равно(Тип("Массив"));
    Ожидаем.Что(ПустойСписок.Количество()).Равно(0);
    
    // Заполненный список
    ЗаполненныйСписок = Смешанное.Получить("filled_list");
    Ожидаем.Что(ТипЗнч(ЗаполненныйСписок)).Равно(Тип("Массив"));
    Ожидаем.Что(ЗаполненныйСписок.Количество()).Равно(3);
    
    // Пустой словарь
    ПустойСловарь = Смешанное.Получить("empty_dict");
    Ожидаем.Что(ТипЗнч(ПустойСловарь)).Равно(Тип("Соответствие"));
    Ожидаем.Что(ПустойСловарь.Количество()).Равно(0);
    
    // Заполненный словарь
    ЗаполненныйСловарь = Смешанное.Получить("filled_dict");
    Ожидаем.Что(ТипЗнч(ЗаполненныйСловарь)).Равно(Тип("Соответствие"));
    Ожидаем.Что(ЗаполненныйСловарь.Количество()).Равно(1);
    
    // Null список
    НullСписок = Смешанное.Получить("null_list");
    Ожидаем.Что(НullСписок).ЭтоНеопределено();
    
    // Неявно пустое значение
    НеявноПустое = Смешанное.Получить("implicit_empty");
    Ожидаем.Что(НеявноПустое).ЭтоНеопределено();
КонецПроцедуры

&Тест
Процедура ТестКомплексныхПустыхКоллекций() Экспорт
    // Дано
    СодержимоеФайла = ТестовыеУтилиты.ПрочитатьТекстФайла(ТестовыеУтилиты.ПолучитьПутьКТестовымДанным("empty_collections.yaml"));
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СодержимоеФайла);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    
    // Проверяем простые пустые коллекции
    ПустойМассив = Результат.Получить("empty_array");
    Ожидаем.Что(ТипЗнч(ПустойМассив)).Равно(Тип("Массив"));
    Ожидаем.Что(ПустойМассив.Количество()).Равно(0);
    
    ПустойОбъект = Результат.Получить("empty_object");
    Ожидаем.Что(ТипЗнч(ПустойОбъект)).Равно(Тип("Соответствие"));
    Ожидаем.Что(ПустойОбъект.Количество()).Равно(0);
    
    // Проверяем пустые значения
    НullЗначение = Результат.Получить("null_value");
    Ожидаем.Что(НullЗначение).ЭтоНеопределено();
    
    ТильдаЗначение = Результат.Получить("tilde_value");
    Ожидаем.Что(ТильдаЗначение).ЭтоНеопределено();
    
    НеявноПустое = Результат.Получить("implicit_empty");
    Ожидаем.Что(НеявноПустое).ЭтоНеопределено();
    
    // Проверяем вложенные пустые коллекции
    ВложенныеПустые = Результат.Получить("nested_empty");
    Ожидаем.Что(ВложенныеПустые).Не_().ЭтоНеопределено();
    
    МассивыВложенных = ВложенныеПустые.Получить("arrays");
    Ожидаем.Что(ТипЗнч(МассивыВложенных)).Равно(Тип("Массив"));
    Ожидаем.Что(МассивыВложенных.Количество()).Равно(3);
    
    // Первый элемент - пустой массив
    ПервыйЭлемент = МассивыВложенных[0];
    Ожидаем.Что(ТипЗнч(ПервыйЭлемент)).Равно(Тип("Массив"));
    Ожидаем.Что(ПервыйЭлемент.Количество()).Равно(0);
    
    // Второй элемент - заполненный массив
    ВторойЭлемент = МассивыВложенных[1];
    Ожидаем.Что(ТипЗнч(ВторойЭлемент)).Равно(Тип("Массив"));
    Ожидаем.Что(ВторойЭлемент.Количество()).Равно(3);
    
    // Третий элемент - пустой массив
    ТретийЭлемент = МассивыВложенных[2];
    Ожидаем.Что(ТипЗнч(ТретийЭлемент)).Равно(Тип("Массив"));
    Ожидаем.Что(ТретийЭлемент.Количество()).Равно(0);
КонецПроцедуры

&Тест
Процедура ТестМассиваСПустымиЭлементами() Экспорт
    // Дано
    СодержимоеФайла = ТестовыеУтилиты.ПрочитатьТекстФайла(ТестовыеУтилиты.ПолучитьПутьКТестовымДанным("empty_collections.yaml"));
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СодержимоеФайла);
    
    // Тогда
    МассивСПустыми = Результат.Получить("array_with_empty_elements");
    Ожидаем.Что(ТипЗнч(МассивСПустыми)).Равно(Тип("Массив"));
    Ожидаем.Что(МассивСПустыми.Количество()).Равно(6);
    
    // Проверяем каждый элемент
    Ожидаем.Что(МассивСПустыми[0]).Равно("first_item");
    
    // Пустой массив
    Ожидаем.Что(ТипЗнч(МассивСПустыми[1])).Равно(Тип("Массив"));
    Ожидаем.Что(МассивСПустыми[1].Количество()).Равно(0);
    
    // Пустой объект
    Ожидаем.Что(ТипЗнч(МассивСПустыми[2])).Равно(Тип("Соответствие"));
    Ожидаем.Что(МассивСПустыми[2].Количество()).Равно(0);
    
    // null значение
    Ожидаем.Что(МассивСПустыми[3]).ЭтоНеопределено();
    
    // ~ значение
    Ожидаем.Что(МассивСПустыми[4]).ЭтоНеопределено();
    
    Ожидаем.Что(МассивСПустыми[5]).Равно("second_item");
КонецПроцедуры

&Тест
Процедура ТестОбъектаСПустымиПолями() Экспорт
    // Дано
    СодержимоеФайла = ТестовыеУтилиты.ПрочитатьТекстФайла(ТестовыеУтилиты.ПолучитьПутьКТестовымДанным("empty_collections.yaml"));
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СодержимоеФайла);
    
    // Тогда
    ОбъектСПустыми = Результат.Получить("object_with_empty_fields");
    Ожидаем.Что(ТипЗнч(ОбъектСПустыми)).Равно(Тип("Соответствие"));
    
    // Обычное поле
    Ожидаем.Что(ОбъектСПустыми.Получить("regular_field")).Равно("value");
    
    // Пустой массив
    ПустойМассив = ОбъектСПустыми.Получить("empty_array_field");
    Ожидаем.Что(ТипЗнч(ПустойМассив)).Равно(Тип("Массив"));
    Ожидаем.Что(ПустойМассив.Количество()).Равно(0);
    
    // Пустой объект
    ПустойОбъект = ОбъектСПустыми.Получить("empty_object_field");
    Ожидаем.Что(ТипЗнч(ПустойОбъект)).Равно(Тип("Соответствие"));
    Ожидаем.Что(ПустойОбъект.Количество()).Равно(0);
    
    // null поле
    НullПоле = ОбъектСПустыми.Получить("null_field");
    Ожидаем.Что(НullПоле).ЭтоНеопределено();
    
    // ~ поле
    ТильдаПоле = ОбъектСПустыми.Получить("tilde_field");
    Ожидаем.Что(ТильдаПоле).ЭтоНеопределено();
    
    // Пустое поле
    ПустоеПоле = ОбъектСПустыми.Получить("empty_field");
    Ожидаем.Что(ПустоеПоле).ЭтоНеопределено();
КонецПроцедуры

&Тест
Процедура ТестГлубокоВложенныхПустыхСтруктур() Экспорт
    // Дано
    СодержимоеФайла = ТестовыеУтилиты.ПрочитатьТекстФайла(ТестовыеУтилиты.ПолучитьПутьКТестовымДанным("empty_collections.yaml"));
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СодержимоеФайла);
    
    // Тогда
    ГлубокиеПустые = Результат.Получить("deep_empty");
    Ожидаем.Что(ГлубокиеПустые).Не_().ЭтоНеопределено();
    
    Уровень1 = ГлубокиеПустые.Получить("level1");
    Ожидаем.Что(Уровень1).Не_().ЭтоНеопределено();
    
    Уровень2 = Уровень1.Получить("level2");
    Ожидаем.Что(Уровень2).Не_().ЭтоНеопределено();
    
    Уровень3 = Уровень2.Получить("level3");
    Ожидаем.Что(Уровень3).Не_().ЭтоНеопределено();
    
    // Проверяем пустые массивы на глубоком уровне
    ПустыеМассивы = Уровень3.Получить("empty_arrays");
    Ожидаем.Что(ТипЗнч(ПустыеМассивы)).Равно(Тип("Массив"));
    Ожидаем.Что(ПустыеМассивы.Количество()).Равно(0);
    
    // Проверяем пустые объекты на глубоком уровне
    ПустыеОбъекты = Уровень3.Получить("empty_objects");
    Ожидаем.Что(ТипЗнч(ПустыеОбъекты)).Равно(Тип("Соответствие"));
    Ожидаем.Что(ПустыеОбъекты.Количество()).Равно(0);
    
    // Проверяем null значения на глубоком уровне
    НullЗначения = Уровень3.Получить("null_values");
    Ожидаем.Что(НullЗначения).ЭтоНеопределено();
    
    // Проверяем неявно пустые значения на глубоком уровне
    НеявноПустые = Уровень3.Получить("implicit_empty");
    Ожидаем.Что(НеявноПустые).ЭтоНеопределено();
КонецПроцедуры

&Тест
Процедура ТестПустыхКоллекцийВBlockStyle() Экспорт
    // Дано
    СтрокаYAML = 
    "config:
    |  database:
    |    host: localhost
    |    port: 5432
    |    credentials:
    |    settings:
    |      timeout: 30
    |      retries:
    |  application:
    |    debug: true
    |    features:
    |    logging:
    |      level: info
    |      handlers:";
    СтрокаYAML = СтрЗаменить(СтрокаYAML, "|", "");
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СтрокаYAML);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    
    Конфигурация = Результат.Получить("config");
    Ожидаем.Что(Конфигурация).Не_().ЭтоНеопределено();
    
    // Проверяем базу данных
    БД = Конфигурация.Получить("database");
    Ожидаем.Что(БД).Не_().ЭтоНеопределено();
    Ожидаем.Что(БД.Получить("host")).Равно("localhost");
    Ожидаем.Что(БД.Получить("port")).Равно(5432);
    
    // Проверяем пустые поля в базе данных
    Учетные = БД.Получить("credentials");
    Ожидаем.Что(Учетные).ЭтоНеопределено();
    
    Настройки = БД.Получить("settings");
    Ожидаем.Что(Настройки).Не_().ЭтоНеопределено();
    Ожидаем.Что(Настройки.Получить("timeout")).Равно(30);
    
    Попытки = Настройки.Получить("retries");
    Ожидаем.Что(Попытки).ЭтоНеопределено();
    
    // Проверяем приложение
    Приложение = Конфигурация.Получить("application");
    Ожидаем.Что(Приложение).Не_().ЭтоНеопределено();
    Ожидаем.Что(Приложение.Получить("debug")).Равно(Истина);
    
    // Проверяем пустые поля в приложении
    Возможности = Приложение.Получить("features");
    Ожидаем.Что(Возможности).ЭтоНеопределено();
    
    Лог = Приложение.Получить("logging");
    Ожидаем.Что(Лог).Не_().ЭтоНеопределено();
    Ожидаем.Что(Лог.Получить("level")).Равно("info");
    
    Обработчики = Лог.Получить("handlers");
    Ожидаем.Что(Обработчики).ЭтоНеопределено();
КонецПроцедуры

&Тест 
Процедура ТестПустыхМассивовВBlockStyle() Экспорт
    // Дано
    СтрокаYAML = 
    "items:
    |  users:
    |  products:
    |    - name: Product 1
    |      price: 100
    |    - name: Product 2
    |      price: 200
    |  categories:
    |  settings:
    |    timeout: 30
    |    retries:";
    СтрокаYAML = СтрЗаменить(СтрокаYAML, "|", "");
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СтрокаYAML);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    
    Элементы = Результат.Получить("items");
    Ожидаем.Что(Элементы).Не_().ЭтоНеопределено();
    
    // Пустой массив пользователей
    Пользователи = Элементы.Получить("users");
    Ожидаем.Что(Пользователи).ЭтоНеопределено();
    
    // Заполненный массив продуктов
    Продукты = Элементы.Получить("products");
    Ожидаем.Что(Продукты).Не_().ЭтоНеопределено();
    Ожидаем.Что(ТипЗнч(Продукты)).Равно(Тип("Массив"));
    Ожидаем.Что(Продукты.Количество()).Равно(2);
    
    // Пустой массив категорий
    Категории = Элементы.Получить("categories");
    Ожидаем.Что(Категории).ЭтоНеопределено();
    
    // Настройки с пустым полем
    Настройки = Элементы.Получить("settings");
    Ожидаем.Что(Настройки).Не_().ЭтоНеопределено();
    Ожидаем.Что(Настройки.Получить("timeout")).Равно(30);
    
    Попытки = Настройки.Получить("retries");
    Ожидаем.Что(Попытки).ЭтоНеопределено();
КонецПроцедуры

&Тест
Процедура ТестДемонстрацииПустыхКоллекций() Экспорт
    // Дано
    СодержимоеФайла = ТестовыеУтилиты.ПрочитатьТекстФайла(ТестовыеУтилиты.ПолучитьПутьКТестовымДанным("demo_empty.yaml"));
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СодержимоеФайла);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    
    // Flow Style пустые коллекции
    ПустойFlowМассив = Результат.Получить("empty_flow_array");
    Ожидаем.Что(ТипЗнч(ПустойFlowМассив)).Равно(Тип("Массив"));
    Ожидаем.Что(ПустойFlowМассив.Количество()).Равно(0);
    
    ПустойFlowОбъект = Результат.Получить("empty_flow_object");
    Ожидаем.Что(ТипЗнч(ПустойFlowОбъект)).Равно(Тип("Соответствие"));
    Ожидаем.Что(ПустойFlowОбъект.Количество()).Равно(0);
    
    // Block Style пустые коллекции (неявные)
    ПустойBlockМассив = Результат.Получить("empty_block_array");
    Ожидаем.Что(ПустойBlockМассив).ЭтоНеопределено();
    
    ПустойBlockОбъект = Результат.Получить("empty_block_object");
    Ожидаем.Что(ПустойBlockОбъект).ЭтоНеопределено();
    
    // Явные null значения
    НullМассив = Результат.Получить("null_array");
    Ожидаем.Что(НullМассив).ЭтоНеопределено();
    
    НullОбъект = Результат.Получить("null_object");
    Ожидаем.Что(НullОбъект).ЭтоНеопределено();
    
    ТильдаМассив = Результат.Получить("tilde_array");
    Ожидаем.Что(ТильдаМассив).ЭтоНеопределено();
    
    ТильдаОбъект = Результат.Получить("tilde_object");
    Ожидаем.Что(ТильдаОбъект).ЭтоНеопределено();
    
    // Смешанные случаи
    СмешаннаяКоллекция = Результат.Получить("mixed_collection");
    Ожидаем.Что(СмешаннаяКоллекция).Не_().ЭтоНеопределено();
    
    // Заполненный массив
    ЗаполненныйМассив = СмешаннаяКоллекция.Получить("filled_array");
    Ожидаем.Что(ТипЗнч(ЗаполненныйМассив)).Равно(Тип("Массив"));
    Ожидаем.Что(ЗаполненныйМассив.Количество()).Равно(3);
    
    // Пустой массив
    ПустойМассив = СмешаннаяКоллекция.Получить("empty_array");
    Ожидаем.Что(ТипЗнч(ПустойМассив)).Равно(Тип("Массив"));
    Ожидаем.Что(ПустойМассив.Количество()).Равно(0);
    
    // Заполненный объект
    ЗаполненныйОбъект = СмешаннаяКоллекция.Получить("filled_object");
    Ожидаем.Что(ТипЗнч(ЗаполненныйОбъект)).Равно(Тип("Соответствие"));
    Ожидаем.Что(ЗаполненныйОбъект.Количество()).Равно(2);
    Ожидаем.Что(ЗаполненныйОбъект.Получить("name")).Равно("test");
    Ожидаем.Что(ЗаполненныйОбъект.Получить("value")).Равно(123);
    
    // Пустой объект
    ПустойОбъект = СмешаннаяКоллекция.Получить("empty_object");
    Ожидаем.Что(ТипЗнч(ПустойОбъект)).Равно(Тип("Соответствие"));
    Ожидаем.Что(ПустойОбъект.Количество()).Равно(0);
    
    // Null поле
    НullПоле = СмешаннаяКоллекция.Получить("null_field");
    Ожидаем.Что(НullПоле).ЭтоНеопределено();
    
    // Неявно пустое поле
    НеявноПустое = СмешаннаяКоллекция.Получить("implicit_empty");
    Ожидаем.Что(НеявноПустое).ЭтоНеопределено();
КонецПроцедуры
