#Использовать asserts
#Использовать ".."
#Использовать "."

&ТестовыйНабор
Процедура ПриСозданииОбъекта() Экспорт
КонецПроцедуры

&Тест
Процедура ТестПарсингаСложнойСтруктуры() Экспорт
    // Дано
    СодержимоеФайла = ТестовыеУтилиты.ПрочитатьТекстФайла(ТестовыеУтилиты.ПолучитьПутьКТестовымДанным("complex.yaml"));
    ЧтениеYaml = ТестовыеУтилиты.СоздатьЭкземплярПарсера();
    
    // Когда
    Результат = ЧтениеYaml.ПрочитатьYaml(СодержимоеФайла);
    
    // Тогда
    Ожидаем.Что(Результат).Не_().ЭтоНеопределено();
    
    Компания = Результат.Получить("company");
    Ожидаем.Что(Компания).Не_().ЭтоНеопределено();
    Ожидаем.Что(Компания.Получить("name")).Равно("Tech Corp");
    
    // Проверяем массив сотрудников
    Сотрудники = Компания.Получить("employees");
    Ожидаем.Что(Сотрудники).Не_().ЭтоНеопределено();
    Ожидаем.Что(Сотрудники.Количество()).Равно(2);
    
    // Первый сотрудник
    Сотрудник1 = Сотрудники[0];
    Ожидаем.Что(Сотрудник1.Получить("name")).Равно("John");
    Ожидаем.Что(Сотрудник1.Получить("age")).Равно(30);
    Ожидаем.Что(Сотрудник1.Получить("position")).Равно("Developer");
    
    // Второй сотрудник
    Сотрудник2 = Сотрудники[1];
    Ожидаем.Что(Сотрудник2.Получить("name")).Равно("Jane");
    Ожидаем.Что(Сотрудник2.Получить("age")).Равно(28);
    Ожидаем.Что(Сотрудник2.Получить("position")).Равно("Designer");
    
    // Проверяем отделы
    Отделы = Компания.Получить("departments");
    Ожидаем.Что(Отделы).Не_().ЭтоНеопределено();
    
    Инженерия = Отделы.Получить("engineering");
    Ожидаем.Что(Инженерия.Получить("budget")).Равно(100000);
    Ожидаем.Что(Инженерия.Получить("head")).Равно("Bob");
    
    Маркетинг = Отделы.Получить("marketing");
    Ожидаем.Что(Маркетинг.Получить("budget")).Равно(50000);
    Ожидаем.Что(Маркетинг.Получить("head")).Равно("Alice");
КонецПроцедуры
